//+------------------------------------------------------------------+
//|                                                        Bands.mq4 |
//|        // //         Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"
//+------------------------------------------------------------------+
//|                                                      BandsR2.mq4 |
//|    Revised Oct 13 2008 Added High/Low Audio Alerts & Options     |
//|                                        ( itemsdepot@hotmail.com) |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Gray
#property indicator_color2 OliveDrab
#property indicator_color3 Brown

#property indicator_width1 1
#property indicator_width2 3
#property indicator_width3 3 

//

//---- indicator parameters
extern bool   DrawBands=True;
extern int    DrawRange=100;
extern int    BandsPeriod=7;
extern int    BandsShift=0;
extern double BandsDeviations=2.0;
extern bool   AlertBoxOn=False;
extern bool   SoundAlertHighOn=False;
extern bool   SoundAlertLowOn=False;
extern string WaveFileName="bandup.wav";
extern string WaveFileName2="banddown.wav";
extern double AlarmDelay=5.0;
extern double Counter=0;
//---- buffers
double MovingBuffer[];
double UpperBuffer[];
double LowerBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   //---- indicators

   if (DrawBands) SetIndexStyle(0,0,0,indicator_width1,indicator_color1); 
     else SetIndexStyle(0,12,0,indicator_width1,indicator_color1);
     
   SetIndexBuffer(0,MovingBuffer);
   
   if (DrawBands) SetIndexStyle(1,0,0,indicator_width2,indicator_color2); 
     else SetIndexStyle(1,12,0,indicator_width2,indicator_color2); 
       
   SetIndexBuffer(1,UpperBuffer);
   
   if (DrawBands) SetIndexStyle(2,0,0,indicator_width3,indicator_color3); 
     else SetIndexStyle(2,12,0,indicator_width3,indicator_color3);
        
   SetIndexBuffer(2,LowerBuffer);   
   
   //----
   SetIndexDrawBegin(0,BandsPeriod+BandsShift);
   SetIndexDrawBegin(1,BandsPeriod+BandsShift);
   SetIndexDrawBegin(2,BandsPeriod+BandsShift);
   //----
   Counter=TimeCurrent();
   AlarmDelay=5;
   return(0);
  }
  
  
//+------------------------------------------------------------------+
//| Bollinger Bands                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int    i,k,counted_bars=IndicatorCounted();
   double deviation;
   double sum,oldval,newres;
   double FinishTime=TimeCurrent();
//----
   if(Bars<=BandsPeriod) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=BandsPeriod;i++)
        {
         MovingBuffer[Bars-i]=EMPTY_VALUE;
         UpperBuffer[Bars-i]=EMPTY_VALUE;
         LowerBuffer[Bars-i]=EMPTY_VALUE;
        }
//----
   //int limit=Bars-counted_bars;
   //if(counted_bars>0) limit++;
   //if ( limit > 50 ) limit = 50;     //dah draw limit 6 hrs on 1M
   for(i=DrawRange; i>=0; i--)
      MovingBuffer[i]=iMA(NULL,0,BandsPeriod,BandsShift,MODE_SMA,PRICE_CLOSE,i);
//----
   //i=Bars-BandsPeriod+1;
   //if(counted_bars>BandsPeriod-1) i=Bars-counted_bars-1;
   i=DrawRange;
   //----------------------------------    
   while(i>=0)
     {
      sum=0.0;
      k=i+BandsPeriod-1;
      oldval=MovingBuffer[i];
      while(k>=i)
        {
         newres=Close[k]-oldval;
         sum+=newres*newres;
         k--;
        }
      deviation=BandsDeviations*MathSqrt(sum/BandsPeriod);
      if (oldval>0) UpperBuffer[i]=oldval+deviation;
      if (oldval>0) LowerBuffer[i]=oldval-deviation;
          
      FinishTime=TimeCurrent();
      
      if (( FinishTime - Counter > AlarmDelay ) && i==0)
      {
        
        Counter=FinishTime;
        if (High[i] > UpperBuffer[i] && AlertBoxOn   ) Print("BandsR1: Candle:"+i+" High Cross: "+High[i]);
        if (High[i] > UpperBuffer[i] && SoundAlertHighOn ) PlaySound(WaveFileName);
      
         if (Low[i] < LowerBuffer[i] && AlertBoxOn   ) Print("BandsR1: Candle:"+i+" Low- Cross: "+Low[i]);
         if (Low[i] < LowerBuffer[i] && SoundAlertLowOn ) PlaySound(WaveFileName2);
      
      }
                
      i--;
      
     }
     //----
   return(0);
  }
//+------------------------------------------------------------------+